import { Inject, Injectable } from '@nestjs/common';
import { RouteProviderPort } from '../core/application/ports/route-provider.port';
import { GetBasicRouteControllerPort } from '@modules/geography/core/application/ports/get-basic-route-controller.port';
import { AD_GET_BASIC_ROUTE_CONTROLLER } from '../ad.di-tokens';
import { Point, Route } from '@modules/geography/core/domain/route.types';

@Injectable()
export class RouteProvider implements RouteProviderPort {
  constructor(
    @Inject(AD_GET_BASIC_ROUTE_CONTROLLER)
    private readonly getBasicRouteController: GetBasicRouteControllerPort,
  ) {}

  getBasic = async (waypoints: Point[]): Promise<Route> =>
    await this.getBasicRouteController.get({
      waypoints,
    });
}
